facts - senan_db 				%com.:        ()
  det(string)
  noun(string)
  rel(string)
  verb(string)
  qw(string)
  cor(string)
  exept(string)


domains						%com.:  
  
  DETERM	=  none ; determ(string)
  NOUNP		 =  nounp( DETERM, string, RELCL)  
  RELCL		   =  none ; relcl(string,VERBP)
  SENTENCE    =  sent( NOUNP, VERBP)
  VERBP		  =  verb(string) ; verbp(string, NOUNP)
  TOKL		    =  string*			%com.:  
  QTOLK		  =  string*

predicates					%com.: "" 
% Recognition of words in different forms
  is_det(string)
  is_noun(string)
  is_rel(string)
  is_verb(string)

% Parser
  nondeterm s_determ(TOKL,TOKL,DETERM)
  nondeterm s_nounp(TOKL,TOKL,NOUNP)
  nondeterm s_relcl(TOKL,TOKL,RELCL)
  nondeterm s_sentence(TOKL,TOKL,SENTENCE)
  nondeterm s_verbp(TOKL,TOKL,VERBP)
  nondeterm s_qsentence(TOKL)

% scanner
  check(string)
  tokl(string,TOKL)
  qtokl(string,TOKL)

clauses						%com.:  
						/*com.:   s_*,      .
							         ,   
							  .    -     , 
							-   (,  ).
							        .  
							 :  ,      
							 (  ),  ;    -  . 
							      ,  
							     ,    
							  ,   -  , .. ,     
							.       ,     
							  :   .  */
						


  s_sentence(TOKL,TOKL2,sent(NOUNP,VERBP)):- 	%com.: :    ,  
	s_nounp(TOKL,TOKL1,NOUNP),		%com.:     , 	
	s_verbp(TOKL1,TOKL2,VERBP),		%com.:    -  ,  
	TOKL2=[],				%com.:     ( ).
	!.					%com.: :  ,      . 
  s_sentence(_,_,_):-
	write(">> Sentence not recognized\n"),	%com.:    , ,   .
	fail.

  s_nounp(TOKL,TOKL2,nounp(DETERM,NOUN,RELCL)):-%com.:   -   
	s_determ(TOKL,[NOUN|TOKL1],DETERM),	%com.:  (  ),  
	is_noun(NOUN),				%com.: ,    
	s_relcl(TOKL1,TOKL2,RELCL).	%com.:   ( ).

  s_determ([DETERM|TOKL],TOKL,determ(DETERM)):- %com.: :     
	is_det(DETERM).				%com.: .
  s_determ(TOKL,TOKL,none).			%com.:  -  ,     .
  

  s_relcl([REL|TOKL],TOKL1,relcl(REL,VERBP)):-	%com.:  :    
	is_rel(REL),				%com.: ,     	
	s_verbp(TOKL,TOKL1,VERBP).		%com.:  .	
  s_relcl(TOKL,TOKL,none).			%com.:         , , 
  						%com.:  ,   .

  s_verbp([VERB|TOKL],TOKL1,verbp(VERB,NOUNP)):-%com.:  :    
	is_verb(VERB),				%com.: ,   
	s_nounp(TOKL,TOKL1,NOUNP),
	write(VERB," -    - ",NOUNP,"\n").		%com.:  .
  s_verbp([VERB|TOKL],TOKL,verb(VERB)):-	%com.: ,      
	is_verb(VERB),				%com.: .
	write(VERB," -   \n").

  /*com.: ------------part of speech--------------*/
  
  is_noun(X):-	noun(X),  !.				
  is_noun(X):-	noun(Y),  concat(Y,"s",X),  !.		
  is_noun(X):-	noun(Y),  concat(Y,"es",X),  !.   /*com.: --------added----------*/
		
  is_det(X):-  det(X),  !. 
  is_det(X):-  det(Y),  concat(Y,"er",X),    !.       /*com.: --------added----------*/ 
  
  is_rel(X):-  rel(X),  !.

  is_verb(X):-  verb(X),  !.
  is_verb(X):-	verb(Y),  concat(Y,"s",X), !.
  is_verb(X):-	verb(Y),  concat(Y,"ed",X), !.
  is_verb(X):-  verb(Y),  concat(Y,"d",X), !.
  is_verb(X):-  verb(Y),  concat(Y,"es",X), !.
  is_verb(X):-	verb(Y),  concat(Y,"ing",X), !.	
  	
  /*com.: --------end part of speech----------*/
  
  
    s_qsentence([QTOKL]):- 	%com.: :    ,  
	qw(QTOKL),
	write(">> Accept the question\n"), !.
    s_qsentence(_):-
	write(">> Not question\n"),	%com.:    , ,   .
	fail.

   tokl(STR,[TOK|TOKL]):-		/*com.: ,     (list -  ) .
  						 :  ,     
  						  ,      .
  						      .  :
  						  ,     ,
  						      ( ).
  					*/
	fronttoken(STR,TOK,STR1),	/*com.:   fronttoken (STRING String, STRING Token, STRING RestString)
						    String,   - Token,   RestString*/
	
	
	check(TOK),			/*com.: ,     */
	!,				/*com.: :        ,
						 -     */
	tokl(STR1,TOKL).		/*com.:   */
  tokl(_,[]).				/*com.:   */

  /*com.:  */

   qtokl(STR,[TOK]):-		
	fronttoken(STR,TOK,STR1),
	write(">>special question>>",TOK,">>",STR1,"\n"),				
	!.
  
  /*com.: ----------check word---------*/
  
   check(WORD):- exept(WORD),   write(WORD, " - {warning: incorrect form of  plural noun!}\n"),  !.
   check(WORD):- exept(WORD),   write(WORD, " - {warning: incorrect form of  plural noun!}\n"),  !.
   
   check(WORD):- cor(WORD), noun(WORD), write(WORD, " - {noun: plural }\n"),  !.
   check(WORD):- cor(WORD), noun(WORD), write(WORD, " - {noun: plural }\n"),  !.
  
   check(WORD):- noun(WORD),  write(WORD, " - {noun: singular}\n"), !.	 
   check(WORD):- noun(Y),  concat(Y,"s",WORD),  write(WORD, " - {noun: plural, ending - s }\n"), !.
   check(WORD):- noun(Y),  concat(Y,"es",WORD),  write(WORD, " - {noun: plural, ending - es} \n"), !.
   check(WORD):- det(WORD),  !.	
   check(WORD):- rel(WORD),   !.
   check(WORD):- verb(WORD),   write(WORD, " - {werb: time - presant simple} \n"), !.
   check(WORD):- verb(Y),  concat(Y,"s",WORD), write(WORD, " - {werb: time - presant simple, ending - s }\n"),  !.
   check(WORD):- verb(Y),  concat(Y,"es",WORD), write(WORD, " - {werb: time - presant simple, ending - es }\n"),   !.
   check(WORD):- verb(Y),  concat(Y,"d",WORD), write(WORD, " - {werb: time - past simple, ending - d }\n"),  !.
   check(WORD):- verb(Y),  concat(Y,"ed",WORD), write(WORD, " - {werb: time - past simple, ending - ed }\n"),  !.
   check(WORD):- verb(Y),  concat(Y,"ing",WORD), write(WORD, " - {werb: time - presant continues, ending - ing }\n"),  !.
   

   
   check(WORD):-				
	write(">> Unknown word: ",WORD),
	nl.
   /*com.: -------end check word---------*/
   
  
goal	%com.:  Goal   ,   -    .   .
  consult("sen_an.dba",senan_db),			%com.:  ,  .
  write("For example: every man that lives loves a woman\n"),	%com.:    .
  write("Please, write a sentence: "),				%com.:     .
  readln(STR),						%com.:  .
  tokl(STR,TOKL),					%com.:      .
  write(TOKL,"\n"),
  s_sentence(TOKL,RESTTOKL,SENT),			%com.:  .
  RESTTOKL=[],						%com.:        
  write(SENT,"\n"),					%com.:  .
  
  
  write("Please, ask your questions\n"),
  readln(QSTR),
  qtokl(QSTR, QTOKL),
  s_qsentence(QTOKL),
  write(QSTR, QTOKL,"\n"),
  write("end\n").
  
  
